﻿freebox-tools: une boite à outils pour votre Freebox
====================================================

<div lang="en">

### English note:

The use of this project implies that you use as a Internet service provider `Free`
and that you use one of the` Freebox` based on `FreeboxOs`. To do this you must
live in France, this is why the documentation is only in French.

This is not an official Free app.

<div>


### Note :

L’utilisation de ce projet implique que vous utilisiez comme prestataire de
service Internet `Free` et que vous utilisiez l’une des `Freebox` basée sur
`FreeboxOs`. Pour ce faire vous devez habiter en France, c’est pourquoi la
documentation n’est qu’en français.

Adresse source du projet : https://git.cclaude.rocks/tools/freebox-tools

Ce n’est pas une application officielle de Freebox, elle est testée avec une
Freebox `Mini 4k` mais elle est compatible avec les modèles de Freebox basés
sur `FreeboxOs`: Freebox Révolution, mini, One, Delta et Pop.


### Limitations

Ce programme s’appuie sur la [documentation officielle](https://dev.freebox.fr/sdk/os/)
qui se limite à documenter les versions 2, 3 et 4 de l’API.

Les **versions suivantes** ne sont hélas plus documentés de manière publique (elles sont disponibles uniquement dans l’interface de la **freebox**).

Certaines options qui étaient configurables ne le sont plus. En particulier à
partir de la version 8 de l’API le contrôle parental a été limité et il n'est
plus possible de bloquer à priori les machines — les machines inconnues ont donc
accès au réseau (et à Internet) sans autre formalité, une régression critique en
ce qui me concerne.

-----

Profiter de votre **Freebox** directement depuis la ligne de commande. Elle vous
permet d’accéder simplement à toute l’API de **Freeboxos**, et propose des accès
simplifier pour :

* Redémarrer votre **Freebox**,
* Redémarrer vos **boîtiers CPL**,
* Voir les machines présentées sur votre réseau et celles connues de votre
**Freebox** qui ne sont actuellement pas en ligne,

Cette application est prévue pour fonctionner sous **Linux**, cependant elle devrait également tourner sous **Windows 10** en activant le sous-système Linux.


Prérequis commun
----------------

* Une **FreeBox** supportant l’API web : une **Freebox Mini** ou une **Freebox V6**,
* Le shell `bash`.

Pour vérifier que votre **Freebox** supporte cette application, utilisez l’URL :
[http://mafreebox.freebox.fr/api_version](http://mafreebox.freebox.fr/api_version).
Si ce lien vous donne accès à des informations techniques, qu’il ne vous
retourne pas d’erreur, c’est que votre **Freebox** est supportée.


### Prérequis sous Linux

Rien de plus, notez que les applications `curl` et `jq` sont nécessaires et
qu’elles sont ajoutées à votre système par la procédure d’installation si
nécessaire (support de `apt-get` et `yum`).


### Prérequis sous Windows 10 avec le sous-système Linux

A priori, il vous faut suivre les instructions pour Linux.


### Prérequis sous Windows sans sous-système Linux

Il est possible de faire tourner ce projet sur tous les **Windows**, même sans
utiliser le conteneur Linux, simplement en installant [git](https://git-scm.com/download/)
(il s’agit de l’implémentation originale de `git` incluant pour Windows un `bash`
complet), [curl](https://curl.haxx.se/windows/) et [jq](https://stedolan.github.io/jq/download/).

Il vous faudra suivre les instructions _sans installation_.


Récupération du projet
-----------------------

Pour télécharger intégralement ce projet, vous devez utiliser :

```bash
git clone --recurse-submodules https://git.cclaude.rocks/tools/freebox-tools.git
```


Sans installation
-----------------

L’installation n’est pas obligatoire, si vous ne faites pas cette étape
assurez-vous de mettre le chemin complet et si nécessaire d’ajuster les
droits d’exécution (le nom de la commande sera alors `freebox.sh').

En particulier pour lancer une commande vous devrez utiliser quelque chose
comme :

```bash
cd LE_REPERTOIRE_DE_CE_PROJET
./freebox.sh --help
```

(Attention au `./` en début de commande)

ou encore

```bash
bash <LE_REPERTOIRE_DE_CE_PROJET>/freebox.sh --help
```

ou si le chemin contient un espace :

```bash
bash "<LE_REPERTOIRE_DE_CE_PROJET>/freebox.sh" --help
```

Et assurez-vous d’avoir les commandes `curl` et `jq` et si nécessaire utilisez (notez que l’installeur essayera de le faire pour vous) :

```bash
sudo apt update && sudo apt install -y curl jq
```


Installation
------------

Pour installer l’application sur un système Linux, mettez-vous dans le
répertoire du projet et exécutez la commande suivante :

```bash
sudo bash ./freebox-tools-install.sh
```

Pour supprimer l’application, vous devrez utiliser la commande :

```bash
sudo bash /usr/local/share/freebox-tools/freebox-tools-remove.sh
```


### Options d’installation

Vous pouvez utiliser la commande suivante pour obtenir l’aide :

```bash
bash ./freebox-tools-install.sh --help
```

| Option                            | Description                                                           |
|-----------------------------------|-----------------------------------------------------------------------|
| -S, --skip-update                 | Ne traite pas la mise à jour du cache du gestionnaire de paquet |
| -P PMEXE, --package-manager PMEXE | Force le binaire à utiliser comme gestionnaire de paquet |


Note préalable
--------------

La commande `freebox` va de préférence utiliser des URLs lié au domaine de votre
box en utilisant le protocole sécurisé `https`. Le but étant de pouvoir vous
permettre de prendre le contrôle de votre box à distance.

Si le domaine de votre box n’est pas défini, la commande tentera d’utiliser le
nom défini en locale à savoir `mafreebox.freebox.fr` également en utilisant le
protocole `https`.

Cependant le protocole `https` nécessite une clé SSL considéré comme étant une
clé de confiance par votre machine, ce qui n’est probablement pas votre cas.
Si vous souhaitez prendre en compte les certificats de votre **Freebox**, vous
devez suivre les explications données dans [CERTIFICATS.md](CERTIFICATS.md).

Si pour une raison ou une autre vous ne souhaitez pas installer les certificats
de **Free**, vous devrez contourner ce problème, à l’aide d’une des deux
solutions disponibles :

* Ajouter le paramètre `--insecure` qui autorise les connexions non certifiées
lors de l’utilisation du protocole `https`.
* Ajouter le paramètre `--allow-http` qui demande à la commande `freebox`
d’utiliser le protocole `http` si aucune connexion `https` n’a pu être trouvée.

Vous pouvez bien-sur ajouter les 2 paramètres simultanément à la commande
`freebox`, pour bénéficier des deux solutions.

```
Si vous n’avez rien compris à cette section ou si la sécurité ne vous intéresse
pas, ajoutez systématiquement, à la commande, les paramètres :

--insecure --allow-http

À commencer par :

freebox --init-token --insecure --allow-http
```

Vous pouvez également ajouter à votre fichier `~/.bashrc` les lignes suivantes :

```bash

# Configuration de freebox-tools
export FREEBOX_INSECURE=true
export FREEBOX_HTTPS_ONLY=true

```

Configuration
-------------

Pour donner les droits à cette application sur votre **Freebox** :

```bash
freebox --init-token
```

Ensuite vous devrez suivre les instructions affichées sur votre **Freebox** pour
autoriser l’application.

Suivant la version de votre **Freebox**, vous pourriez être amené à donner des
droits supplémentaires depuis l’[interface de configuration](http://mafreebox.freebox.fr).

Cela se trouve dans « Paramètres de la Freebox », onglet « Mode avancé »,
« Gestion des accès », onglet « Applications ». Sur cette fenêtre vous trouverez
pour chaque application, un bouton « éditer » permettant d’ajouter ou de retirer
des droits.

### Liste des droits

* Accès au contrôle parental
* Accès à la base de contacts de la Freebox
* Accès aux fichiers de la Freebox
* Accès au guide TV
* Provisionnement des équipements
* Accès au gestionnaire de téléchargements
* Gestion des profils utilisateur
* Accès aux caméras
* Modification des réglages de la Freebox
* Accès au journal d’appels
* Gestion de l’alarme et maison connectée
* Programmation des enregistrements
* Contrôle de la VM
* Contrôle du Freebox Player


Aide en ligne
-------------

Une aide en ligne est disponible en utilisant :

```bash
freebox --help
```


Principales commandes
---------------------

### Redémarrer votre **Freebox**

Attention, cette action peut nécessiter des droits supplémentaires que vous pourrez accorder à l’application depuis l’[interface de votre FreeBox](http://mafreebox.freebox.fr/).

```bash
freebox --restart
```

### Affiche les informations disponibles sur l’API de votre Freebox.

```bash
freebox --api
```


### Affiche certaines informations de connexion de votre Freebox.

```bash
freebox --connection
```


### Récupérer les adresses MAC connues par votre Freebox

Il s’agit des adresses trouvées sur votre réseau (et visible par votre
Freebox).

```bash
freebox --show-mac-address
```


### Récupérer la liste des machines connues par votre Freebox

Il s’agit des machines s’étant connectés avec succès au moins une fois dessus.
Vous pouvez ainsi récupérer l’IP qui lui a été attribuée, son adresse MAC, son
nom…

L’affichage par défaut est au format JSON :

```bash
freebox --display-hosts
```

Si vous préférez un affichage texte :

```bash
freebox --display-hosts-text
```

Les informations retournées sont les suivantes :

* Adresse IPv4
* Adresse IPv6
* Adresse MAC
* Type de la machine
* Constructeur de la machine
* Nom de la machine

Vous pouvez, si nécessaire, changer les séparateurs de colonne et de fin de
ligne :

```bash
freebox --display-hosts-text --separator ';' --last-separator '*'
```


### Gestion de vos boîtiers CPL (Freeplug)

Les **Freeplugs** disponibles avec certaines **Freebox** sont compatibles avec
les **Boîtiers CPL** du marché. Voici comment contrôler vos boîtiers **CPL**.

Pour obtenir la liste des boîtiers connus par votre **Freebox** :

```bash
freebox --plug
```

Le résultat est retourné au format JSON et peut être exploité avec par exemple
la commande `jq`. Vous noterez la présence d’un champ `id` nécessaire à la
commande suivante.

Redémarrage du boîtier CPL donné :

```bash
freebox --plug-reset ID
```

Redémarrage de tous les boîtiers CPL trouvés.

```bash
freebox --plug-reset-all
```

### Voir toutes les machines connues :

```bash
freebox --hosts
```


### Modifier l’accès internet d’une machine, plus exactement d’un profil

Attention la machine doit être définie dans un **Profil**, il s’agit de la fonctionnalité qui s’appelait **Contrôle Parental**.

#### Par profil

Si vous connaissez le numéro d’identification du profil, vous pouvez utiliser :

```bash
freebox --network-disable-by-profile 28
```

```bash
freebox --network-enable-by-profile 28
```

La liste des profils s’obtenant à l’aide de :

```bash
freebox --profile
```

#### Par adresse MAC

Si vous connaissez l’adresse MAC d’une machine appartenant au profil, vous pouvez utiliser l’adresse MAC comme suite (L’adresse MAC doit être en majuscule) :

```bash
freebox --network-disable-by-mac 'CE:AC:A5:67:32:CC'
```

```bash
freebox --network-enable-by-mac 'CE:AC:A5:67:32:CC'
```

Vous pouvez utiliser la commande suivante, pour retrouver l’adresse MAC à utiliser :

```bash
freebox --network-control
```


### GET - Récupérer le résultat d’un appel à l’API de votre choix

```bash
freebox get URI
```

Le résultat sera au format JSON.

Quelques exemples :

* Caractéristique de votre ligne : `freebox get /connection/xdsl`
* Voir votre configuration DHCP : `freebox get /dhcp/config`
* Afficher les règles de délégations (forwarding) : `freebox get /fw/redir/`

### PUT et POST - Support des requêtes de type PUT et POST

Les requêtes de type PUT et POST sont également supportées, celle-ci sont destinés à modifier
la configuration de votre **Freebox**.

```bash
freebox post URI --data DATA
```

```bash
freebox put URI --data DATA
```


### Exemple un peu plus complet

Par exemple pour voir la liste des ports redirigés :

* Au format JSON

```bash
freebox get '/fw/redir/' | jq '[ .result[].lan_port ]'
```

* Au format brut

```bash
freebox get '/fw/redir/' | jq -r '.result[].lan_port'
```

Par exemple, si vous souhaitez savoir où les ports 80 (http) et 443 (https)
sont redirigés :

```bash
freebox get '/fw/redir/' | jq '[ .result[] | select(.lan_port == 80 or .lan_port==443) ]'
```

Afficher les informations liées à une adresse IP :

```bash
freebox --hosts | jq '.result[] | select( (.l3connectivities // [])[].addr == "192.168.1.60" )'
```

Explications :

Pour comprendre ce dernier exemple, analysez ces résultats :

* Affichage brut de la requête

```bash
freebox --hosts | jq '[ .result[] ]'
```

* Filtre que les résultats liés à la connectivité (niveau 3) – Notez que certaines valeurs peuvent être 'null'

```bash
freebox --hosts | jq '[ .result[] | .l3connectivities ]'
```

* Même résultat mais sans valeur 'null' (on remplace par un tableau vide)

```bash
freebox --hosts | jq '[ .result[] | .l3connectivities // [] ]'
```

* Du coup on peut parcourir tous les tableaux

```bash
freebox --hosts | jq '[ .result[] | .l3connectivities // [] | .[] ]'
```

* Et filtrer seulement les adresses (IPv4 ou IPv6)

```bash
freebox --hosts | jq '[ .result[] | .l3connectivities // [] | .[] | .addr ]'
```

* Et finalement (pour récupérer toute l’information liée à une IP)

```bash
freebox --hosts | jq '.result[] | select( (.l3connectivities // [])[].addr == "__UNE_DES_IP__" )'
```

Analysons le filtre `jq` utilisé plus haut :

```
.result[] | select( (.l3connectivities // [])[].addr == "192.168.1.60" )
```

| Expression                                | Interprétation par `jq` |
|-------------------------------------------|-------------------------|
| `.result[]`                               | Découpe le tableau résultat (un bloc JSON par entrée) |
| `\|`                                      | Pour chaque entrée faire… |
| `select( EXPRESSION1 == "192.168.1.60" )` | On ne prend (affiche) que celle· qui vérifie strictement l’égalité. |
| `.l3connectivities[].addr`                | On prend chaque `addr` dans le tableau `l3connectivities`. Mais attention si le tableau `l3connectivities` n’existe pas il y a une erreur. |
| `(.l3connectivities // [])[].addr`        | (Pour résoudre l’erreur) Si le tableau `l3connectivities` n’existe pas, on le remplace par un tableau vide. |

Commandes bonus
---------------

### freebox-lcd

Juste pour s'ammuser

```bash
freebox-lcd --help # Pour l’aide
```

### freebox-reset-plugs

Un raccourci pour :

```bash
freebox --plug-reset-all
```

### freebox-wifi

Permet d'activer ou de désactiver le WIFI de la **Freebox**

```bash
freebox-wifi --help # Pour l’aide
```


Documentations de références
----------------------------

**Attention** cette documentation publique est obsolète. La documentation à jour est disponible directement dans l’interface de la **Freebox**,
ce qui veut dire qu’il n’y a plus de documentation publique.

* FreeboxOS [Developper API Documentation](https://dev.freebox.fr/sdk/os/)
    * FreeboxOS [Connection](https://dev.freebox.fr/sdk/os/connection)
    * FreeboxOS [DHCP API](https://dev.freebox.fr/sdk/os/dhcp/)
    * FreeboxOS [Download API](https://dev.freebox.fr/sdk/os/download/)
    * FreeboxOS [LAN browser API](https://dev.freebox.fr/sdk/os/lan/#lan-browser)
    * FreeboxOS [Contrôle parental](https://dev.freebox.fr/sdk/os/parental/#)
* [Documentation et blog pour les développeures](https://dev.freebox.fr/) chez Free.
* Linux [Filesystem Hierarchy Standard 2.3](http://www.pathname.com/fhs/pub/fhs-2.3.html)
* Autres sites où il est possible de trouver de l’information (au cas par cas):
    * https://www.universfreebox.com/
    * https://www.freezone.fr/

