#!/bin/bash
#
# freebox-tools:bin/api/freebox-plug-api.sh
#
function _freebox_reset_plug_ {
  local -r id="$1"
  echoinfo "Rédémarrage du plug: ${id}" >&2

  local result=
  result="$( freebox_api_post "/freeplug/${id}/reset/" )" || return $?

  local success=
  success="$( jq -r '.success' <<<"${result}" )" || return $?

  jq --null-input \
     --arg id "${id}" \
     --arg success "${success}" '{ id: $id, success: $success }' || return $?
}

function _freebox_reset_all_plugs_raw_ {
  local plug_list=
  plug_list="$( freebox_api_get '/freeplug' )" || return $?
  plug_list="$( jq -c '.result[] | { id: .id, ids: [ .members[].id ] }' <<<"${plug_list}" )" || return $?
  local -r plug_list

  echoinfo "Plugs: '${plug_list}'" >&2
  local ids=
  ids="$( jq -r '.ids[]' <<<"${plug_list}" )" || return $?
  local -r ids

  local id=
  while read -r id ; do
    if [ -n "${id}" ] ; then
      _freebox_reset_plug_ "${id}" || true # Ignore errors
     fi
  done <<<"${ids}"
}

function freebox_reset_all_plugs {
  _freebox_reset_all_plugs_raw_ | jq --slurp '.' || return $?
}
