#!/bin/bash -e
#
# freebox-tools:apis/install-commons.sh
#

#
# Accoring to: http://www.pathname.com/fhs/pub/fhs-2.3.html
#
# Put everything into: /usr/local/share/freebox-tools,
# Ensure *.sh are executables and readonly,
# Add links into: /usr/bin
#
declare -grx INSTALL_DATA_DIR='/usr/local/share/freebox-tools'
declare -grx INSTALL_BIN_DIR='/usr/bin'

declare -grx REMOVE_OLD="${INSTALL_DATA_DIR}/freebox-remove.sh"
declare -grx REMOVE_EXE="${INSTALL_DATA_DIR}/freebox-tools-remove.sh"

declare -grx INSTALL_LINKS='
freebox
freebox-internet-access
freebox-lcd
freebox-reset-plugs
freebox-wifi
'

declare -grx INSTALL_EXE='
bin/freebox-internet-access.sh
bin/freebox-lcd.sh
bin/freebox-reset-plugs.sh
bin/freebox-wifi.sh
bin/freebox.sh
freebox-tools-install.sh
freebox-tools-remove.sh
'

declare -grax INSTALL_PACKAGES=( curl jq )
declare -grax INSTALL_API_INSTALL_MAIN_EXCLUDE=(
'.git'
'.gitignore'
'.gitlab-ci.yml'
'.gitmodules'
'.target'
'package'
'tests'
)
